ViewVC Help
View File | Revision Log | Show Annotations | Download File | Root Listing
root/radiance/ray/src/util/genBSDF.pl
Revision: 2.48
Committed: Wed Jul 9 15:03:11 2014 UTC (9 years, 8 months ago) by greg
Content type: text/plain
Branch: MAIN
CVS Tags: rad4R2P2, rad4R2, rad4R2P1
Changes since 2.47: +4 -1 lines
Log Message:
Added warning for -t3 w/o +forward and +backward

File Contents

# Content
1 #!/usr/bin/perl -w
2 # RCSid $Id: genBSDF.pl,v 2.47 2014/04/24 23:08:08 greg Exp $
3 #
4 # Compute BSDF based on geometry and material description
5 #
6 # G. Ward
7 #
8 use strict;
9 my $windoz = ($^O eq "MSWin32" or $^O eq "MSWin64");
10 use File::Temp qw/ :mktemp /;
11 sub userror {
12 print STDERR "Usage: genBSDF [-n Nproc][-c Nsamp][-t{3|4} Nlog2][-r \"ropts\"][-dim xmin xmax ymin ymax zmin zmax][{+|-}f][{+|-}b][{+|-}mgf][{+|-}geom units] [input ..]\n";
13 exit 1;
14 }
15 my ($td,$radscn,$mgfscn,$octree,$cnttmp,$rmtmp);
16 if ($windoz) {
17 my $tmploc = `echo \%TMP\%`;
18 chomp($tmploc);
19 $td = mkdtemp("$tmploc\\genBSDF.XXXXXX");
20 $radscn = "$td\\device.rad";
21 $mgfscn = "$td\\device.mgf";
22 $octree = "$td\\device.oct";
23 chomp $td;
24 $rmtmp = "rmdir /S /Q $td";
25 } else{
26 $td = mkdtemp("/tmp/genBSDF.XXXXXX");
27 chomp $td;
28 $radscn = "$td/device.rad";
29 $mgfscn = "$td/device.mgf";
30 $octree = "$td/device.oct";
31 $rmtmp = "rm -rf $td";
32 }
33 my @savedARGV = @ARGV;
34 my $tensortree = 0;
35 my $ttlog2 = 4;
36 my $nsamp = 2000;
37 my $rtargs = "-w -ab 5 -ad 700 -lw 3e-6";
38 my $mgfin = 0;
39 my $geout = 1;
40 my $nproc = 1;
41 my $doforw = 0;
42 my $doback = 1;
43 my $pctcull = 90;
44 my $gunit = "meter";
45 my @dim;
46 # Get options
47 while ($#ARGV >= 0) {
48 if ("$ARGV[0]" =~ /^[-+]m/) {
49 $mgfin = ("$ARGV[0]" =~ /^\+/);
50 } elsif ("$ARGV[0]" eq "-r") {
51 $rtargs = "$rtargs $ARGV[1]";
52 shift @ARGV;
53 } elsif ("$ARGV[0]" =~ /^[-+]g/) {
54 $geout = ("$ARGV[0]" =~ /^\+/);
55 $gunit = $ARGV[1];
56 if ($gunit !~ /^(?i)(meter|foot|inch|centimeter|millimeter)$/) {
57 die "Illegal geometry unit '$gunit': must be meter, foot, inch, centimeter, or millimeter\n";
58 }
59 shift @ARGV;
60 } elsif ("$ARGV[0]" =~ /^[-+]f/) {
61 $doforw = ("$ARGV[0]" =~ /^\+/);
62 } elsif ("$ARGV[0]" =~ /^[-+]b/) {
63 $doback = ("$ARGV[0]" =~ /^\+/);
64 } elsif ("$ARGV[0]" eq "-t") {
65 # Use value < 0 for rttree_reduce bypass
66 $pctcull = $ARGV[1];
67 shift @ARGV;
68 } elsif ("$ARGV[0]" =~ /^-t[34]$/) {
69 $tensortree = substr($ARGV[0], 2, 1);
70 $ttlog2 = $ARGV[1];
71 shift @ARGV;
72 } elsif ("$ARGV[0]" eq "-c") {
73 $nsamp = $ARGV[1];
74 shift @ARGV;
75 } elsif ("$ARGV[0]" eq "-n") {
76 $nproc = $ARGV[1];
77 shift @ARGV;
78 } elsif ("$ARGV[0]" =~ /^-d/) {
79 userror() if ($#ARGV < 6);
80 @dim = @ARGV[1..6];
81 shift @ARGV for (1..6);
82 } elsif ("$ARGV[0]" =~ /^[-+]./) {
83 userror();
84 } else {
85 last;
86 }
87 shift @ARGV;
88 }
89 # Check that we're actually being asked to do something
90 die "Must have at least one of +forward or +backward\n" if (!$doforw && !$doback);
91 # Issue warning for unhandled reciprocity case
92 print STDERR "Warning: recommend both +forward and +backward with -t3" if
93 ($tensortree==3 && !($doforw && $doback));
94 # Get scene description and dimensions
95
96 if ( $mgfin ) {
97 system qq{mgfilt "#,o,xf,c,cxy,cspec,cmix,m,sides,rd,td,rs,ts,ir,v,p,n,f,fh,sph,cyl,cone,prism,ring,torus" @ARGV > $mgfscn};
98 die "Could not load MGF input\n" if ( $? );
99 system "mgf2rad $mgfscn > $radscn";
100 } else {
101 system "xform -e @ARGV > $radscn";
102 die "Could not load Radiance input\n" if ( $? );
103 system "rad2mgf $radscn > $mgfscn" if ( $geout );
104 }
105 if ($#dim != 5) {
106 @dim = split ' ', `getbbox -h $radscn`;
107 }
108 print STDERR "Warning: Device extends into room\n" if ($dim[5] > 1e-5);
109 # Add receiver surfaces (rectangular)
110 my $fmodnm="receiver_face";
111 my $bmodnm="receiver_behind";
112 open(RADSCN, ">> $radscn");
113 print RADSCN "void glow $fmodnm\n0\n0\n4 1 1 1 0\n\n";
114 print RADSCN "$fmodnm source f_receiver\n0\n0\n4 0 0 1 180\n";
115 print RADSCN "void glow $bmodnm\n0\n0\n4 1 1 1 0\n\n";
116 print RADSCN "$bmodnm source b_receiver\n0\n0\n4 0 0 -1 180\n";
117 close RADSCN;
118 # Generate octree
119 system "oconv -w $radscn > $octree";
120 die "Could not compile scene\n" if ( $? );
121 # Output XML prologue
122 print
123 '<?xml version="1.0" encoding="UTF-8"?>
124 <WindowElement xmlns="http://windows.lbl.gov" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="http://windows.lbl.gov/BSDF-v1.4.xsd">
125 ';
126 print "<!-- File produced by: genBSDF @savedARGV -->\n";
127 print
128 '<WindowElementType>System</WindowElementType>
129 <FileType>BSDF</FileType>
130 <Optical>
131 <Layer>
132 <Material>
133 <Name>Name</Name>
134 <Manufacturer>Manufacturer</Manufacturer>
135 ';
136 printf qq{\t\t<Thickness unit="$gunit">%.6f</Thickness>\n}, $dim[5] - $dim[4];
137 printf qq{\t\t<Width unit="$gunit">%.6f</Width>\n}, $dim[1] - $dim[0];
138 printf qq{\t\t<Height unit="$gunit">%.6f</Height>\n}, $dim[3] - $dim[2];
139 print "\t\t<DeviceType>Other</DeviceType>\n";
140 print "\t</Material>\n";
141 # Output MGF description if requested
142 if ( $geout ) {
143 print qq{\t\t<Geometry format="MGF">\n};
144 print qq{\t\t<MGFblock unit="$gunit">\n};
145 printf "xf -t %.6f %.6f 0\n", -($dim[0]+$dim[1])/2, -($dim[2]+$dim[3])/2;
146 open(MGFSCN, "< $mgfscn");
147 while (<MGFSCN>) { print $_; }
148 close MGFSCN;
149 print "xf\n";
150 print "</MGFblock>\n";
151 print "\t</Geometry>\n";
152 }
153 # Set up surface sampling
154 my $nx = int(sqrt($nsamp*($dim[1]-$dim[0])/($dim[3]-$dim[2])) + 1);
155 my $ny = int($nsamp/$nx + 1);
156 $nsamp = $nx * $ny;
157 my $ns = 2**$ttlog2;
158 my (@pdiv, $disk2sq, $sq2disk, $tcal, $kcal);
159 # Create data segments (all the work happens here)
160 if ( $tensortree ) {
161 do_tree_bsdf();
162 } else {
163 do_matrix_bsdf();
164 }
165 # Output XML epilogue
166 print
167 '</Layer>
168 </Optical>
169 </WindowElement>
170 ';
171 # Clean up temporary files and exit
172 system $rmtmp;
173
174 #-------------- End of main program segment --------------#
175
176 #++++++++++++++ Tensor tree BSDF generation ++++++++++++++#
177 sub do_tree_bsdf {
178 # Shirley-Chiu mapping from unit square to disk
179 $sq2disk = 'in_square_a = 2*in_square_x - 1; ' .
180 'in_square_b = 2*in_square_y - 1; ' .
181 'in_square_rgn = if(in_square_a + in_square_b, ' .
182 'if(in_square_a - in_square_b, 1, 2), ' .
183 'if(in_square_b - in_square_a, 3, 4)); ' .
184 'out_disk_r = .999995*select(in_square_rgn, in_square_a, in_square_b, ' .
185 '-in_square_a, -in_square_b); ' .
186 'out_disk_phi = PI/4 * select(in_square_rgn, ' .
187 'in_square_b/in_square_a, ' .
188 '2 - in_square_a/in_square_b, ' .
189 '4 + in_square_b/in_square_a, ' .
190 'if(in_square_b*in_square_b, ' .
191 '6 - in_square_a/in_square_b, 0)); ' .
192 'Dx = out_disk_r*cos(out_disk_phi); ' .
193 'Dy = out_disk_r*sin(out_disk_phi); ' .
194 'Dz = sqrt(1 - out_disk_r*out_disk_r);' ;
195 # Shirley-Chiu mapping from unit disk to square
196 $disk2sq = 'norm_radians(p) : if(-p - PI/4, p + 2*PI, p); ' .
197 'in_disk_r = .999995*sqrt(Dx*Dx + Dy*Dy); ' .
198 'in_disk_phi = norm_radians(atan2(Dy, Dx)); ' .
199 'in_disk_rgn = floor((.999995*in_disk_phi + PI/4)/(PI/2)) + 1; ' .
200 'out_square_a = select(in_disk_rgn, ' .
201 'in_disk_r, ' .
202 '(PI/2 - in_disk_phi)*in_disk_r/(PI/4), ' .
203 '-in_disk_r, ' .
204 '(in_disk_phi - 3*PI/2)*in_disk_r/(PI/4)); ' .
205 'out_square_b = select(in_disk_rgn, ' .
206 'in_disk_phi*in_disk_r/(PI/4), ' .
207 'in_disk_r, ' .
208 '(PI - in_disk_phi)*in_disk_r/(PI/4), ' .
209 '-in_disk_r); ' .
210 'out_square_x = (out_square_a + 1)/2; ' .
211 'out_square_y = (out_square_b + 1)/2;';
212 # Announce ourselves in XML output
213 print "\t<DataDefinition>\n";
214 print "\t\t<IncidentDataStructure>TensorTree$tensortree</IncidentDataStructure>\n";
215 print "\t</DataDefinition>\n";
216
217 # Start rcontrib processes for compute each side
218 do_tree_rtcontrib(0) if ( $doback );
219 do_tree_rtcontrib(1) if ( $doforw );
220
221 } # end of sub do_tree_bsdf()
222
223 # Run rcontrib process to generate tensor tree samples
224 sub do_tree_rtcontrib {
225 my $forw = shift;
226 my $cmd;
227 my $matargs = "-m $bmodnm";
228 if ( !$forw || !$doback || $tensortree==3 ) { $matargs .= " -m $fmodnm"; }
229 if ($windoz) {
230 $cmd = "rcontrib $rtargs -h -faa -fo -n $nproc -c $nsamp " .
231 qq{-e "$disk2sq" -bn "$ns*$ns" } .
232 qq{-b "$ns*floor(out_square_x*$ns)+floor(out_square_y*$ns)" } .
233 "-o $td/%s.flt $matargs $octree";
234 } else {
235 $cmd = "rcontrib $rtargs -h -fff -fo -n $nproc -c $nsamp " .
236 qq{-e "$disk2sq" -bn "$ns*$ns" } .
237 qq{-b "$ns*floor(out_square_x*$ns)+floor(out_square_y*$ns)" } .
238 "-o $td/%s.flt $matargs $octree";
239 }
240 if ( $tensortree == 3 ) {
241 # Isotropic BSDF
242 my $ns2 = $ns / 2;
243 if ($windoz) {
244 $cmd = "cnt $ns2 $ny $nx " .
245 qq{| rcalc -e "r1=rand(.8681*recno-.673892)" } .
246 qq{-e "r2=rand(-5.37138*recno+67.1737811)" } .
247 qq{-e "r3=rand(+3.17603772*recno+83.766771)" } .
248 qq{-e "Dx=1-2*(\$1+r1)/$ns;Dy:0;Dz=sqrt(1-Dx*Dx)" } .
249 qq{-e "xp=(\$3+r2)*(($dim[1]-$dim[0])/$nx)+$dim[0]" } .
250 qq{-e "yp=(\$2+r3)*(($dim[3]-$dim[2])/$ny)+$dim[2]" } .
251 qq{-e "zp=$dim[5-$forw]" -e "myDz=Dz*($forw*2-1)" } .
252 qq{-e "\$1=xp-Dx;\$2=yp-Dy;\$3=zp-myDz" } .
253 qq{-e "\$4=Dx;\$5=Dy;\$6=myDz" } .
254 "| $cmd";
255 } else {
256 $cmd = "cnt $ns2 $ny $nx " .
257 qq{| rcalc -e "r1=rand(.8681*recno-.673892)" } .
258 qq{-e "r2=rand(-5.37138*recno+67.1737811)" } .
259 qq{-e "r3=rand(+3.17603772*recno+83.766771)" } .
260 qq{-e "Dx=1-2*(\$1+r1)/$ns;Dy:0;Dz=sqrt(1-Dx*Dx)" } .
261 qq{-e "xp=(\$3+r2)*(($dim[1]-$dim[0])/$nx)+$dim[0]" } .
262 qq{-e "yp=(\$2+r3)*(($dim[3]-$dim[2])/$ny)+$dim[2]" } .
263 qq{-e "zp=$dim[5-$forw]" -e "myDz=Dz*($forw*2-1)" } .
264 qq{-e '\$1=xp-Dx;\$2=yp-Dy;\$3=zp-myDz' } .
265 qq{-e '\$4=Dx;\$5=Dy;\$6=myDz' -of } .
266 "| $cmd";
267 }
268 } else {
269 # Anisotropic BSDF
270 # Sample area vertically to improve load balance, since
271 # shading systems usually have bilateral symmetry (L-R)
272 if ($windoz) {
273 $cmd = "cnt $ns $ns $ny $nx " .
274 qq{| rcalc -e "r1=rand(.8681*recno-.673892)" } .
275 qq{-e "r2=rand(-5.37138*recno+67.1737811)" } .
276 qq{-e "r3=rand(3.17603772*recno+83.766771)" } .
277 qq{-e "r4=rand(-2.3857833*recno-964.72738)" } .
278 qq{-e "in_square_x=(\$1+r1)/$ns" } .
279 qq{-e "in_square_y=(\$2+r2)/$ns" -e "$sq2disk" } .
280 qq{-e "xp=(\$4+r3)*(($dim[1]-$dim[0])/$nx)+$dim[0]" } .
281 qq{-e "yp=(\$3+r4)*(($dim[3]-$dim[2])/$ny)+$dim[2]" } .
282 qq{-e "zp=$dim[5-$forw]" -e "myDz=Dz*($forw*2-1)" } .
283 qq{-e "\$1=xp-Dx;\$2=yp-Dy;\$3=zp-myDz" } .
284 qq{-e "\$4=Dx;\$5=Dy;\$6=myDz" } .
285 "| $cmd";
286 } else {
287 $cmd = "cnt $ns $ns $ny $nx " .
288 qq{| rcalc -e "r1=rand(.8681*recno-.673892)" } .
289 qq{-e "r2=rand(-5.37138*recno+67.1737811)" } .
290 qq{-e "r3=rand(3.17603772*recno+83.766771)" } .
291 qq{-e "r4=rand(-2.3857833*recno-964.72738)" } .
292 qq{-e "in_square_x=(\$1+r1)/$ns" } .
293 qq{-e "in_square_y=(\$2+r2)/$ns" -e "$sq2disk" } .
294 qq{-e "xp=(\$4+r3)*(($dim[1]-$dim[0])/$nx)+$dim[0]" } .
295 qq{-e "yp=(\$3+r4)*(($dim[3]-$dim[2])/$ny)+$dim[2]" } .
296 qq{-e "zp=$dim[5-$forw]" -e "myDz=Dz*($forw*2-1)" } .
297 qq{-e '\$1=xp-Dx;\$2=yp-Dy;\$3=zp-myDz' } .
298 qq{-e '\$4=Dx;\$5=Dy;\$6=myDz' -of } .
299 "| $cmd";
300 }
301 }
302 # print STDERR "Starting: $cmd\n";
303 system "$cmd" || die "Failure running rcontrib";
304 ttree_out($forw);
305 } # end of do_tree_rtcontrib()
306
307 # Simplify and output tensor tree results
308 sub ttree_out {
309 my $forw = shift;
310 my $side = ("Back","Front")[$forw];
311 my $cmd;
312 # Only output one transmitted anisotropic distribution, preferring backwards
313 if ( !$forw || !$doback || $tensortree==3 ) {
314 print
315 ' <WavelengthData>
316 <LayerNumber>System</LayerNumber>
317 <Wavelength unit="Integral">Visible</Wavelength>
318 <SourceSpectrum>CIE Illuminant D65 1nm.ssp</SourceSpectrum>
319 <DetectorSpectrum>ASTM E308 1931 Y.dsp</DetectorSpectrum>
320 <WavelengthDataBlock>' ;
321 print "\t\t\t<WavelengthDataDirection>Transmission $side</WavelengthDataDirection>\n";
322 print
323 ' <AngleBasis>LBNL/Shirley-Chiu</AngleBasis>
324 <ScatteringDataType>BTDF</ScatteringDataType>
325 <ScatteringData>
326 ';
327 if ($windoz) {
328 $cmd = qq{rcalc -e "Omega:PI/($ns*$ns)" } .
329 q{-e "$1=(0.265*$1+0.670*$2+0.065*$3)/Omega" };
330 } else {
331 $cmd = "rcalc -if3 -e 'Omega:PI/($ns*$ns)' " .
332 q{-e '$1=(0.265*$1+0.670*$2+0.065*$3)/Omega' };
333 }
334 if ($pctcull >= 0) {
335 if ($windoz) {
336 $cmd = "rcollate -h -oc 1 $td/" . ($bmodnm,$fmodnm)[$forw] . ".flt | " .
337 $cmd .
338 "| rttree_reduce -h -fa -t $pctcull -r $tensortree -g $ttlog2";
339 } else {
340 $cmd .= "-of $td/" . ($bmodnm,$fmodnm)[$forw] . ".flt " .
341 " | rttree_reduce -h -ff -t $pctcull -r $tensortree -g $ttlog2";
342 }
343 system "$cmd" || die "Failure running rttree_reduce";
344 } else {
345 if ($windoz) {
346 $cmd = "rcollate -h -oc 1 $td/" . ($bmodnm,$fmodnm)[$forw] . ".flt | " .
347 $cmd ;
348 } else {
349 $cmd .= "$td/" . ($bmodnm,$fmodnm)[$forw] . ".flt";
350 }
351 print "{\n";
352 system "$cmd" || die "Failure running rcalc";
353 for (my $i = ($tensortree==3)*$ns*$ns*$ns/2; $i-- > 0; ) {
354 print "0\n";
355 }
356 print "}\n";
357 }
358 print
359 ' </ScatteringData>
360 </WavelengthDataBlock>
361 </WavelengthData>
362 ';
363 }
364 # Output reflection
365 print
366 ' <WavelengthData>
367 <LayerNumber>System</LayerNumber>
368 <Wavelength unit="Integral">Visible</Wavelength>
369 <SourceSpectrum>CIE Illuminant D65 1nm.ssp</SourceSpectrum>
370 <DetectorSpectrum>ASTM E308 1931 Y.dsp</DetectorSpectrum>
371 <WavelengthDataBlock>
372 ';
373 print "\t\t\t<WavelengthDataDirection>Reflection $side</WavelengthDataDirection>\n";
374 print
375 ' <AngleBasis>LBNL/Shirley-Chiu</AngleBasis>
376 <ScatteringDataType>BTDF</ScatteringDataType>
377 <ScatteringData>
378 ';
379 if ($windoz) {
380 $cmd = qq{rcalc -e "Omega:PI/($ns*$ns)" } .
381 q{-e "$1=(0.265*$1+0.670*$2+0.065*$3)/Omega" };
382 }else {
383 $cmd = "rcalc -if3 -e 'Omega:PI/($ns*$ns)' " .
384 q{-e '$1=(0.265*$1+0.670*$2+0.065*$3)/Omega' };
385 }
386 if ($pctcull >= 0) {
387 if ($windoz) {
388 $cmd = "rcollate -h -oc 1 $td/" . ($fmodnm,$bmodnm)[$forw] . ".flt |" .
389 $cmd .
390 " | rttree_reduce -a -h -fa -t $pctcull -r $tensortree -g $ttlog2";
391
392 } else {
393 $cmd .= "-of $td/" . ($fmodnm,$bmodnm)[$forw] . ".flt " .
394 "| rttree_reduce -a -h -ff -t $pctcull -r $tensortree -g $ttlog2";
395 }
396 system "$cmd" || die "Failure running rttree_reduce";
397 } else {
398 if ($windoz) {
399 $cmd = "rcollate -h -oc 1 $td/" . ($fmodnm,$bmodnm)[$forw] . ".flt |" .
400 $cmd ;
401 } else {
402 $cmd .= "$td/" . ($fmodnm,$bmodnm)[$forw] . ".flt";
403 }
404 print "{\n";
405 system "$cmd" || die "Failure running rcalc";
406 for (my $i = ($tensortree==3)*$ns*$ns*$ns/2; $i-- > 0; ) {
407 print "0\n";
408 }
409 print "}\n";
410 }
411 print
412 ' </ScatteringData>
413 </WavelengthDataBlock>
414 </WavelengthData>
415 ';
416 } # end of ttree_out()
417
418 #------------- End of do_tree_bsdf() & subroutines -------------#
419
420 #+++++++++++++++ Klems matrix BSDF generation +++++++++++++++#
421 sub do_matrix_bsdf {
422 # Set up sampling of portal
423 # Kbin to produce incident direction in full Klems basis with (x1,x2) randoms
424 $tcal = 'DEGREE : PI/180; ' .
425 'sq(x) : x*x; ' .
426 'Kpola(r) : select(r+1, 0, 5, 15, 25, 35, 45, 55, 65, 75, 90); ' .
427 'Knaz(r) : select(r, 1, 8, 16, 20, 24, 24, 24, 16, 12); ' .
428 'Kaccum(r) : if(r-.5, Knaz(r) + Kaccum(r-1), 0); ' .
429 'Kmax : Kaccum(Knaz(0)); ' .
430 'Kfindrow(r, rem) : if(rem-Knaz(r)+.5, Kfindrow(r+1, rem-Knaz(r)), r); ' .
431 'Krow = if(Kbin-(Kmax-.5), 0, Kfindrow(1, Kbin)); ' .
432 'Kcol = Kbin - Kaccum(Krow-1); ' .
433 'Kazi = 360*DEGREE * (Kcol + (.5 - x2)) / Knaz(Krow); ' .
434 'Kpol = DEGREE * (x1*Kpola(Krow) + (1-x1)*Kpola(Krow-1)); ' .
435 'sin_kpol = sin(Kpol); ' .
436 'Dx = cos(Kazi)*sin_kpol; ' .
437 'Dy = sin(Kazi)*sin_kpol; ' .
438 'Dz = sqrt(1 - sin_kpol*sin_kpol); ' .
439 'KprojOmega = PI * if(Kbin-.5, ' .
440 '(sq(cos(Kpola(Krow-1)*DEGREE)) - sq(cos(Kpola(Krow)*DEGREE)))/Knaz(Krow), ' .
441 '1 - sq(cos(Kpola(1)*DEGREE))); ';
442 # Compute Klems bin from exiting ray direction (forward or backward)
443 $kcal = 'DEGREE : PI/180; ' .
444 'abs(x) : if(x, x, -x); ' .
445 'Acos(x) : if(x-1, 0, if(-1-x, PI, acos(x)))/DEGREE; ' .
446 'posangle(a) : if(-a, a + 2*PI, a); ' .
447 'Atan2(y,x) : posangle(atan2(y,x))/DEGREE; ' .
448 'kpola(r) : select(r, 5, 15, 25, 35, 45, 55, 65, 75, 90); ' .
449 'knaz(r) : select(r, 1, 8, 16, 20, 24, 24, 24, 16, 12); ' .
450 'kaccum(r) : if(r-.5, knaz(r) + kaccum(r-1), 0); ' .
451 'kfindrow(r, pol) : if(r-kpola(0)+.5, r, ' .
452 'if(pol-kpola(r), kfindrow(r+1, pol), r) ); ' .
453 'kazn(azi,inc) : if((360-.5*inc)-azi, floor((azi+.5*inc)/inc), 0); ' .
454 'kbin2(pol,azi) = select(kfindrow(1, pol), ' .
455 'kazn(azi,360/knaz(1)), ' .
456 'kaccum(1) + kazn(azi,360/knaz(2)), ' .
457 'kaccum(2) + kazn(azi,360/knaz(3)), ' .
458 'kaccum(3) + kazn(azi,360/knaz(4)), ' .
459 'kaccum(4) + kazn(azi,360/knaz(5)), ' .
460 'kaccum(5) + kazn(azi,360/knaz(6)), ' .
461 'kaccum(6) + kazn(azi,360/knaz(7)), ' .
462 'kaccum(7) + kazn(azi,360/knaz(8)), ' .
463 'kaccum(8) + kazn(azi,360/knaz(9)) ' .
464 '); ' .
465 'kbin = kbin2(Acos(abs(Dz)),Atan2(Dy,Dx));';
466 my $ndiv = 145;
467 # Compute scattering data using rcontrib
468 my @tfarr;
469 my @rfarr;
470 my @tbarr;
471 my @rbarr;
472 my (@data,@line); # for windows
473 my $cmd;
474 my $rtcmd;
475 my $rccmd;
476 if ($windoz) {
477 $rtcmd = "rcontrib $rtargs -h -fo -n $nproc -c $nsamp " .
478 qq{-e "$kcal" -b kbin -bn $ndiv } .
479 qq{-o "$td\\%s.flt" -m $fmodnm -m $bmodnm $octree };
480 $rccmd = qq{rcalc -e "$tcal" } .
481 qq{-e "mod(n,d):n-floor(n/d)*d" -e "Kbin=mod(recno-.999,$ndiv)" } .
482 q{ -e "$1=(0.265*$1+0.670*$2+0.065*$3)/KprojOmega" };
483 } else {
484 $rtcmd = "rcontrib $rtargs -h -ff -fo -n $nproc -c $nsamp " .
485 "-e '$kcal' -b kbin -bn $ndiv " .
486 "-o '$td/%s.flt' -m $fmodnm -m $bmodnm $octree";
487 $rccmd = "rcalc -e '$tcal' " .
488 "-e 'mod(n,d):n-floor(n/d)*d' -e 'Kbin=mod(recno-.999,$ndiv)' " .
489 q{-if3 -e '$1=(0.265*$1+0.670*$2+0.065*$3)/KprojOmega' };
490 }
491 if ( $doforw ) {
492 if ($windoz) {
493 $cmd = qq{cnt $ndiv $ny $nx | rcalc -e "$tcal" } .
494 qq{-e "xp=(\$3+rand(.12*recno+288))*(($dim[1]-$dim[0])/$nx)+$dim[0]" } .
495 qq{-e "yp=(\$2+rand(.37*recno-44))*(($dim[3]-$dim[2])/$ny)+$dim[2]" } .
496 qq{-e "zp:$dim[4]" } .
497 q{-e "Kbin=$1;x1=rand(2.75*recno+3.1);x2=rand(-2.01*recno-3.37)" } .
498 q{-e "$1=xp-Dx;$2=yp-Dy;$3=zp-Dz;$4=Dx;$5=Dy;$6=Dz" } .
499 "| $rtcmd ";
500 } else {
501 $cmd = "cnt $ndiv $ny $nx | rcalc -of -e '$tcal' " .
502 "-e 'xp=(\$3+rand(.12*recno+288))*(($dim[1]-$dim[0])/$nx)+$dim[0]' " .
503 "-e 'yp=(\$2+rand(.37*recno-44))*(($dim[3]-$dim[2])/$ny)+$dim[2]' " .
504 "-e 'zp:$dim[4]' " .
505 q{-e 'Kbin=$1;x1=rand(2.75*recno+3.1);x2=rand(-2.01*recno-3.37)' } .
506 q{-e '$1=xp-Dx;$2=yp-Dy;$3=zp-Dz;$4=Dx;$5=Dy;$6=Dz' } .
507 "| $rtcmd";
508 }
509 system "$cmd" || die "Failure running: $cmd\n";
510 if ($windoz) {
511 @tfarr = `rcollate -h -oc 1 $td\\$fmodnm.flt | $rccmd`;
512 } else {
513 @tfarr = `$rccmd $td/$fmodnm.flt`;
514 }
515 die "Failure running: $rccmd $td/$fmodnm.flt\n" if ( $? );
516 if ($windoz) {
517 @rfarr = `rcollate -h -oc 1 $td\\$bmodnm.flt | $rccmd`;
518 } else {
519 @rfarr = `$rccmd $td/$bmodnm.flt`;
520 }
521 die "Failure running: $rccmd $td/$bmodnm.flt\n" if ( $? );
522 }
523 if ( $doback ) {
524 if ($windoz) {
525 $cmd = qq{cnt $ndiv $ny $nx | rcalc -e "$tcal" } .
526 qq{-e "xp=(\$3+rand(.35*recno-15))*(($dim[1]-$dim[0])/$nx)+$dim[0]" } .
527 qq{-e "yp=(\$2+rand(.86*recno+11))*(($dim[3]-$dim[2])/$ny)+$dim[2]" } .
528 qq{-e "zp:$dim[5]" } .
529 q{-e "Kbin=$1;x1=rand(1.21*recno+2.75);x2=rand(-3.55*recno-7.57)" } .
530 q{-e "$1=xp-Dx;$2=yp-Dy;$3=zp+Dz;$4=Dx;$5=Dy;$6=-Dz" } .
531 "| $rtcmd";
532 } else {
533 $cmd = "cnt $ndiv $ny $nx | rcalc -of -e '$tcal' " .
534 "-e 'xp=(\$3+rand(.35*recno-15))*(($dim[1]-$dim[0])/$nx)+$dim[0]' " .
535 "-e 'yp=(\$2+rand(.86*recno+11))*(($dim[3]-$dim[2])/$ny)+$dim[2]' " .
536 "-e 'zp:$dim[5]' " .
537 q{-e 'Kbin=$1;x1=rand(1.21*recno+2.75);x2=rand(-3.55*recno-7.57)' } .
538 q{-e '$1=xp-Dx;$2=yp-Dy;$3=zp+Dz;$4=Dx;$5=Dy;$6=-Dz' } .
539 "| $rtcmd";
540 }
541 system "$cmd" || die "Failure running: $cmd\n";
542 if ($windoz) {
543 @tbarr = `rcollate -h -oc 1 $td\\$bmodnm.flt | $rccmd`;
544 } else {
545 @tbarr = `$rccmd $td/$bmodnm.flt`;
546 }
547 die "Failure running: $rccmd $td/$bmodnm.flt\n" if ( $? );
548 chomp(@tbarr);
549 if ($windoz) {
550 @rbarr = `rcollate -h -oc 1 $td\\$fmodnm.flt | $rccmd`;
551 } else {
552 @rbarr = `$rccmd $td/$fmodnm.flt`;
553 }
554 die "Failure running: $rccmd $td/$fmodnm.flt\n" if ( $? );
555 chomp(@rbarr);
556 }
557
558 # Output angle basis
559 print
560 ' <DataDefinition>
561 <IncidentDataStructure>Columns</IncidentDataStructure>
562 <AngleBasis>
563 <AngleBasisName>LBNL/Klems Full</AngleBasisName>
564 <AngleBasisBlock>
565 <Theta>0</Theta>
566 <nPhis>1</nPhis>
567 <ThetaBounds>
568 <LowerTheta>0</LowerTheta>
569 <UpperTheta>5</UpperTheta>
570 </ThetaBounds>
571 </AngleBasisBlock>
572 <AngleBasisBlock>
573 <Theta>10</Theta>
574 <nPhis>8</nPhis>
575 <ThetaBounds>
576 <LowerTheta>5</LowerTheta>
577 <UpperTheta>15</UpperTheta>
578 </ThetaBounds>
579 </AngleBasisBlock>
580 <AngleBasisBlock>
581 <Theta>20</Theta>
582 <nPhis>16</nPhis>
583 <ThetaBounds>
584 <LowerTheta>15</LowerTheta>
585 <UpperTheta>25</UpperTheta>
586 </ThetaBounds>
587 </AngleBasisBlock>
588 <AngleBasisBlock>
589 <Theta>30</Theta>
590 <nPhis>20</nPhis>
591 <ThetaBounds>
592 <LowerTheta>25</LowerTheta>
593 <UpperTheta>35</UpperTheta>
594 </ThetaBounds>
595 </AngleBasisBlock>
596 <AngleBasisBlock>
597 <Theta>40</Theta>
598 <nPhis>24</nPhis>
599 <ThetaBounds>
600 <LowerTheta>35</LowerTheta>
601 <UpperTheta>45</UpperTheta>
602 </ThetaBounds>
603 </AngleBasisBlock>
604 <AngleBasisBlock>
605 <Theta>50</Theta>
606 <nPhis>24</nPhis>
607 <ThetaBounds>
608 <LowerTheta>45</LowerTheta>
609 <UpperTheta>55</UpperTheta>
610 </ThetaBounds>
611 </AngleBasisBlock>
612 <AngleBasisBlock>
613 <Theta>60</Theta>
614 <nPhis>24</nPhis>
615 <ThetaBounds>
616 <LowerTheta>55</LowerTheta>
617 <UpperTheta>65</UpperTheta>
618 </ThetaBounds>
619 </AngleBasisBlock>
620 <AngleBasisBlock>
621 <Theta>70</Theta>
622 <nPhis>16</nPhis>
623 <ThetaBounds>
624 <LowerTheta>65</LowerTheta>
625 <UpperTheta>75</UpperTheta>
626 </ThetaBounds>
627 </AngleBasisBlock>
628 <AngleBasisBlock>
629 <Theta>82.5</Theta>
630 <nPhis>12</nPhis>
631 <ThetaBounds>
632 <LowerTheta>75</LowerTheta>
633 <UpperTheta>90</UpperTheta>
634 </ThetaBounds>
635 </AngleBasisBlock>
636 </AngleBasis>
637 </DataDefinition>
638 ';
639 if ( $doforw ) {
640 print
641 ' <WavelengthData>
642 <LayerNumber>System</LayerNumber>
643 <Wavelength unit="Integral">Visible</Wavelength>
644 <SourceSpectrum>CIE Illuminant D65 1nm.ssp</SourceSpectrum>
645 <DetectorSpectrum>ASTM E308 1931 Y.dsp</DetectorSpectrum>
646 <WavelengthDataBlock>
647 <WavelengthDataDirection>Transmission Front</WavelengthDataDirection>
648 <ColumnAngleBasis>LBNL/Klems Full</ColumnAngleBasis>
649 <RowAngleBasis>LBNL/Klems Full</RowAngleBasis>
650 <ScatteringDataType>BTDF</ScatteringDataType>
651 <ScatteringData>
652 ';
653 # Output front transmission (transposed order)
654 for (my $od = 0; $od < $ndiv; $od++) {
655 for (my $id = 0; $id < $ndiv; $id++) {
656 chomp $tfarr[$ndiv*$id + $od];
657 print $tfarr[$ndiv*$id + $od], ",\t";
658 }
659 print "\n";
660 }
661 print
662 ' </ScatteringData>
663 </WavelengthDataBlock>
664 </WavelengthData>
665 <WavelengthData>
666 <LayerNumber>System</LayerNumber>
667 <Wavelength unit="Integral">Visible</Wavelength>
668 <SourceSpectrum>CIE Illuminant D65 1nm.ssp</SourceSpectrum>
669 <DetectorSpectrum>ASTM E308 1931 Y.dsp</DetectorSpectrum>
670 <WavelengthDataBlock>
671 <WavelengthDataDirection>Reflection Front</WavelengthDataDirection>
672 <ColumnAngleBasis>LBNL/Klems Full</ColumnAngleBasis>
673 <RowAngleBasis>LBNL/Klems Full</RowAngleBasis>
674 <ScatteringDataType>BTDF</ScatteringDataType>
675 <ScatteringData>
676 ';
677 # Output front reflection (transposed order)
678 for (my $od = 0; $od < $ndiv; $od++) {
679 for (my $id = 0; $id < $ndiv; $id++) {
680 chomp $rfarr[$ndiv*$id + $od];
681 print $rfarr[$ndiv*$id + $od], ",\t";
682 }
683 print "\n";
684 }
685 print
686 ' </ScatteringData>
687 </WavelengthDataBlock>
688 </WavelengthData>
689 ';
690 }
691 if ( $doback ) {
692 print
693 ' <WavelengthData>
694 <LayerNumber>System</LayerNumber>
695 <Wavelength unit="Integral">Visible</Wavelength>
696 <SourceSpectrum>CIE Illuminant D65 1nm.ssp</SourceSpectrum>
697 <DetectorSpectrum>ASTM E308 1931 Y.dsp</DetectorSpectrum>
698 <WavelengthDataBlock>
699 <WavelengthDataDirection>Transmission Back</WavelengthDataDirection>
700 <ColumnAngleBasis>LBNL/Klems Full</ColumnAngleBasis>
701 <RowAngleBasis>LBNL/Klems Full</RowAngleBasis>
702 <ScatteringDataType>BTDF</ScatteringDataType>
703 <ScatteringData>
704 ';
705 # Output back transmission (transposed order)
706 for (my $od = 0; $od < $ndiv; $od++) {
707 for (my $id = 0; $id < $ndiv; $id++) {
708 chomp $tbarr[$ndiv*$id + $od];
709 print $tbarr[$ndiv*$id + $od], ",\t";
710 }
711 print "\n";
712 }
713 print
714 ' </ScatteringData>
715 </WavelengthDataBlock>
716 </WavelengthData>
717 <WavelengthData>
718 <LayerNumber>System</LayerNumber>
719 <Wavelength unit="Integral">Visible</Wavelength>
720 <SourceSpectrum>CIE Illuminant D65 1nm.ssp</SourceSpectrum>
721 <DetectorSpectrum>ASTM E308 1931 Y.dsp</DetectorSpectrum>
722 <WavelengthDataBlock>
723 <WavelengthDataDirection>Reflection Back</WavelengthDataDirection>
724 <ColumnAngleBasis>LBNL/Klems Full</ColumnAngleBasis>
725 <RowAngleBasis>LBNL/Klems Full</RowAngleBasis>
726 <ScatteringDataType>BTDF</ScatteringDataType>
727 <ScatteringData>
728 ';
729 # Output back reflection (transposed order)
730 for (my $od = 0; $od < $ndiv; $od++) {
731 for (my $id = 0; $id < $ndiv; $id++) {
732 chomp $rbarr[$ndiv*$id + $od];
733 print $rbarr[$ndiv*$id + $od], ",\t";
734 }
735 print "\n";
736 }
737 print
738 ' </ScatteringData>
739 </WavelengthDataBlock>
740 </WavelengthData>
741 ';
742 }
743 }
744 #------------- End of do_matrix_bsdf() --------------#